import win32.windows;
import std.string;
import win32frame.writek;
import win32frame.WindowObject ;

class DialogBoxClass : WindowObject {
  HWND parenthwnd ;
  bool is_modeless=false ;

  int  dialog_res ;
  int  dialog_exit ;

  this( string name ) {
    this.dialog_res      = 0 ;
    this.dialog_exit     = 0 ;
    this.winc.cbWndExtra = DLGWINDOWEXTRA ;
    super(name) ;
  }

  int create( DWORD style, int x, int y, int width, int height, HWND phwnd, HMENU hmenu){
    int res ;
    MSG msg;

    res=this.registwinc() ;
    if( res !=0 ){
      writek("wc regist faild.\n") ;
      return(res) ;
    }
    parenthwnd=phwnd ;
    res=lowcreate( cast(uint)(0), style, x, y, width, height, phwnd, hmenu ) ;
    if( res==0 ){
      while(this.dialog_exit==0) {
	GetMessage(&msg,null,0,0);
	if(IsDialogMessage(this.hwnd,&msg)==0){
	  if( is_modeless==true ){
	    TranslateMessage(&msg);
	    DispatchMessage(&msg);
	  }else{
	    if( msg.message==WM_PAINT || msg.message==WM_SYSCOMMAND ){
	      TranslateMessage(&msg);
	      DispatchMessage(&msg);
	    }
	    switch( msg.message ){
	    case WM_LBUTTONDOWN :
	    case WM_RBUTTONDOWN :
	    case WM_MBUTTONDOWN :
	      MessageBeep(MB_OK) ;
	    case WM_SYSCOMMAND :
	      SetFocus(this.hwnd) ;
	      break ;
	    default : break ;
	    }
	  }
	}
      }
    }else{
      return(res) ;
    }
    return( this.dialog_res ) ;
  }

  override LRESULT proc(HWND hwnd , UINT msg , WPARAM wp , LPARAM lp){
    return( DefDlgProc(hwnd , msg , wp , lp) );
  }

  void isModeless(){
    is_modeless=true ;
  }

  void setResult(int res){
    this.dialog_res=res ;
    this.dialog_exit=1 ;
  }
  
  int getDlogState(){
    return(this.dialog_exit) ;
  }

  int getDlogResult(){
    return(this.dialog_res) ;
  }
}
