import win32.windows;
import win32.windef;
import win32.commctrl;

import std.stdio;
import std.string;
import std.utf;

//
// Example:
//  string fname ;
//  fname = getLoadFileName("WaveFrontOBJ {*.obj}\0*.obj\0",parentHWND) ;
//

class FileDialog{

  this(){
  }

  string getSaveFileName(string filematch, HWND parentHWND){
    OPENFILENAME ofn ;
    wchar[]      wfname ;
    string       retstr ;

    wfname.length=MAX_PATH ;
    wfname[0]=0 ;
    
    ofn.lStructSize = OPENFILENAME.sizeof ;
    ofn.hwndOwner   = parentHWND ;
    if( filematch==null ){
      ofn.lpstrFilter = null ;
    }else{
      ofn.lpstrFilter = cast(wchar*)(toUTF16z(filematch)) ;
    }
    ofn.lpstrCustomFilter = null ;
    ofn.lpstrFile   = wfname.ptr ;
    ofn.nMaxFile    = MAX_PATH ;
    ofn.Flags       = OFN_FILEMUSTEXIST ;

    GetSaveFileName(&ofn) ;

    int len ;
    for( len=0 ; len<wfname.length ; len++ ){
      if( wfname[len]==0 ) break ;
    }
    wfname.length=len ;
    
    retstr = std.utf.toUTF8(wfname.idup) ;
    
    return(retstr) ;
  }
  

  string getLoadFileName(string filematch, HWND parentHWND){
    OPENFILENAME ofn ;
    wchar[]      wfname ;
    string       retstr ;

    wfname.length=MAX_PATH ;
    wfname[0]=0 ; //これが無いとGetOpenFileName()に失敗する
    
    ofn.lStructSize = OPENFILENAME.sizeof ;
    ofn.hwndOwner   = parentHWND ;
    if( filematch==null ){
      ofn.lpstrFilter = null ;
    }else{
      ofn.lpstrFilter = cast(wchar*)(toUTF16z(filematch)) ;
    }
    ofn.lpstrCustomFilter = null ;
    ofn.lpstrFile   = wfname.ptr ;
    ofn.nMaxFile    = MAX_PATH ;
    ofn.Flags       = OFN_FILEMUSTEXIST ;

    GetOpenFileName(&ofn) ;

    int len ;
    for( len=0 ; len<wfname.length ; len++ ){
      if( wfname[len]==0 ) break ;
    }
    wfname.length=len ;
    
    retstr = std.utf.toUTF8(wfname.idup) ;
    
    return(retstr) ;
  }
}  
